'-----------------------------------------------------
'Ansteuereungsbeispiel fr CC2Net-RAM-Interface Ports
'CCTools 2002 cctools.hs-control.de (21.08.2002)
'----------------------------------------------------

define DS    Port[9]
define RAMSH Port[10]
define RAMST Port[11]
define RAMWE Port[16]

define cmd byte[2]
define addr word[2]

'RAM-Einsprung-Adressen & Variablen & Konstanten
define READbyte &h113 : define READword &h119
define WRITEbyte &h109 : define WRITEword &h101
define deselect &b00011110
define control Byte[1] 'Register fr I/O-Ports, CS-Leitungen und Bit17(RAM-Addr)
define bit16 Bit[1]
define CS1 Bit[2] 'Chip-Select: Lo=selected, Hi=deselected
define CS2 Bit[3]
define CS3 Bit[4]
define CS4 Bit[5]


put 12
print "CCTools (c)2002";
print "CC2Net-RAM-Dev.";
pause 50
put 12
print "Init...";

gosub RAM_Init
pause 5

put 12
print "Write...";

CS1=0 'RAM 1 selectieren
'ber CS1 bis 4 wird der RAM-Baustein ausgewhlt
'CSx = On od. -1  = Baustein nicht ausgewhlt !
'CSx = Off od. 0  = Baustein ist ausgewhlt !
'Bit16 = On /OF bzw. 0 / -1 = 17tes Adressbit
'der RAM-Bausteine.
'Bit0 bis Bit15 werden mit sys-Aufruf bergeben(addr)


'RAM Beschreiben mit Adresswert
for addr=0 to 512 step 2
 sys WRITEword,addr,addr+10
 put 13
 print "Write...";addr;
next

put 12
print "Read...";

'514 Werte aus dem RAM-Lesen und an der ser.Schnittstelle
'ausgeben
for addr = 0 to 512 step 2
 print read_word;
 put 9
next

print "Ready";
gosub RAM_deselect
end


'----RAM-Funktionen--------------------------
#RAM_Init
 control=&hFE
 RAMWE=On
 DS=Off
 RAMSH=Off
 RAMST=Off
return

#READ_byte
sys READbyte,addr,0
return

#READ_word
sys READword,addr,0
return

#RAM_Deselect
control=control or deselect
sys WRITEbyte,0,0
return

'Byte schreiben:
'sys WRITEbyte,addr,Wert

'Word schreiben:
'sys WRITEword,addr,Wert
'Beim Schreiben von Words mu darauf geachtet
'werden, da nur gerade Adressen angegeben werden
'knnen !


'syscode "ramports.s19" 'Nur einmal laden, dann auskommentieren !
